Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/FileManager.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/FileManager.cs	(revision 17331)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/FileManager.cs	(revision 17331)
@@ -0,0 +1,80 @@
+﻿using System;
+using System.Collections.Generic;
+using System.IO;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using System.Windows.Forms;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.MainForm;
+using HeuristicLab.Optimization;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.JsonInterface.OptimizerIntegration {
+  internal  static class FileManager {
+    private static SaveFileDialog saveFileDialog;
+    private static OpenFileDialog openFileDialog;
+
+    public static void ExportJsonTemplate() {
+      IContentView activeView = MainFormManager.MainForm.ActiveView as IContentView;
+      if (activeView != null) {
+        ExportJsonTemplate(activeView);
+      }
+    }
+    public static void ExportJsonTemplate(IContentView view) {
+      IStorableContent content = view.Content as IStorableContent;
+      if (!view.Locked && content != null) {
+        if (saveFileDialog == null) {
+          saveFileDialog = new SaveFileDialog();
+          saveFileDialog.Title = "Export .json-Template";
+          saveFileDialog.DefaultExt = "json";
+          saveFileDialog.Filter = ".json-Template|*.json|All Files|*.*";
+          saveFileDialog.FilterIndex = 1;
+        }
+
+        INamedItem namedItem = content as INamedItem;
+        string suggestedFileName = string.Empty;
+        if (!string.IsNullOrEmpty(content.Filename)) suggestedFileName = content.Filename;
+        else if (namedItem != null) suggestedFileName = namedItem.Name;
+        else suggestedFileName = "Item";
+
+        saveFileDialog.FileName = suggestedFileName + " " + namedItem.GetType().Name;
+
+        if (saveFileDialog.ShowDialog() == DialogResult.OK) {
+          JCGenerator gen = new JCGenerator();
+          IAlgorithm alg = namedItem as IAlgorithm;
+          Task.Run(() => {
+            File.WriteAllText(saveFileDialog.FileName, gen.GenerateTemplate(alg));
+          });
+        }
+      }
+    }
+
+
+    public static void ImportJsonTemplate() {
+      if (openFileDialog == null) {
+        openFileDialog = new OpenFileDialog();
+        openFileDialog.Title = "Import .json-Template";
+        openFileDialog.FileName = "Item";
+        openFileDialog.Multiselect = false;
+        openFileDialog.DefaultExt = "json";
+        openFileDialog.Filter = ".json-Template|*.json|All Files|*.*";
+      }
+
+      if (openFileDialog.ShowDialog() == DialogResult.OK) {
+        JCInstantiator instantiator = new JCInstantiator();
+        try {
+          var content = instantiator.Instantiate(openFileDialog.FileName);
+          IView view = MainFormManager.MainForm.ShowContent(content);
+          if (view == null)
+            ErrorHandling.ShowErrorDialog("There is no view for the loaded item. It cannot be displayed.", new InvalidOperationException("No View Available"));
+        } catch (Exception ex) {
+          ErrorHandling.ShowErrorDialog((Control)MainFormManager.MainForm, "Cannot open file.", ex);
+        } finally {
+          ((MainForm.WindowsForms.MainForm)MainFormManager.MainForm).ResetAppStartingCursor();
+        }
+      }
+    }
+  }
+}
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/HeuristicLab.JsonInterface.OptimizerIntegration.csproj
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/HeuristicLab.JsonInterface.OptimizerIntegration.csproj	(revision 17331)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/HeuristicLab.JsonInterface.OptimizerIntegration.csproj	(revision 17331)
@@ -0,0 +1,106 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="15.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <Import Project="$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props" Condition="Exists('$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props')" />
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProjectGuid>{5A3413F8-0928-4167-80E7-AAD9D6E38A94}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.JsonInterface.OptimizerIntegration</RootNamespace>
+    <AssemblyName>HeuristicLab.JsonInterface.OptimizerIntegration</AssemblyName>
+    <TargetFrameworkVersion>v4.6.1</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <Deterministic>true</Deterministic>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>..\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup>
+    <SignAssembly>true</SignAssembly>
+  </PropertyGroup>
+  <PropertyGroup>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+    <Reference Include="System.Windows.Forms" />
+    <Reference Include="System.Xml.Linq" />
+    <Reference Include="System.Data.DataSetExtensions" />
+    <Reference Include="Microsoft.CSharp" />
+    <Reference Include="System.Data" />
+    <Reference Include="System.Net.Http" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="FileManager.cs" />
+    <Compile Include="MenuItems\ImportJsonTemplateMenuItem.cs" />
+    <Compile Include="MenuItems\ExportJsonTemplateMenuItem.cs" />
+    <Compile Include="Plugin.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="HeuristicLab.snk" />
+    <None Include="Plugin.cs.frame" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\HeuristicLab.Common\3.3\HeuristicLab.Common-3.3.csproj">
+      <Project>{A9AD58B9-3EF9-4CC1-97E5-8D909039FF5C}</Project>
+      <Name>HeuristicLab.Common-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
+      <Project>{C36BD924-A541-4A00-AFA8-41701378DDC5}</Project>
+      <Name>HeuristicLab.Core-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.JsonInterface\HeuristicLab.JsonInterface.csproj">
+      <Project>{0e3aab5e-f152-44e0-a054-4d9a83ecee08}</Project>
+      <Name>HeuristicLab.JsonInterface</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.MainForm.WindowsForms\3.3\HeuristicLab.MainForm.WindowsForms-3.3.csproj">
+      <Project>{ab687bbe-1bfe-476b-906d-44237135431d}</Project>
+      <Name>HeuristicLab.MainForm.WindowsForms-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.MainForm\3.3\HeuristicLab.MainForm-3.3.csproj">
+      <Project>{3bd61258-31da-4b09-89c0-4f71fef5f05a}</Project>
+      <Name>HeuristicLab.MainForm-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Optimization\3.3\HeuristicLab.Optimization-3.3.csproj">
+      <Project>{14AB8D24-25BC-400C-A846-4627AA945192}</Project>
+      <Name>HeuristicLab.Optimization-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Optimizer\3.3\HeuristicLab.Optimizer-3.3.csproj">
+      <Project>{C664305E-497C-4533-A140-967DEDB05C19}</Project>
+      <Name>HeuristicLab.Optimizer-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.PluginInfrastructure\3.3\HeuristicLab.PluginInfrastructure-3.3.csproj">
+      <Project>{94186a6a-5176-4402-ae83-886557b53cca}</Project>
+      <Name>HeuristicLab.PluginInfrastructure-3.3</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <PropertyGroup>
+    <PreBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+call PreBuildEvent.cmd
+
+</PreBuildEvent>
+  </PropertyGroup>
+</Project>
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/MenuItems/ExportJsonTemplateMenuItem.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/MenuItems/ExportJsonTemplateMenuItem.cs	(revision 17331)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/MenuItems/ExportJsonTemplateMenuItem.cs	(revision 17331)
@@ -0,0 +1,36 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using System.Windows.Forms;
+using HeuristicLab.Common;
+using HeuristicLab.MainForm;
+using HeuristicLab.Optimizer;
+
+namespace HeuristicLab.JsonInterface.OptimizerIntegration {
+  internal class ExportJsonTemplateMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItem, IOptimizerUserInterfaceItemProvider {
+    public override string Name {
+      get { return "Json-Template..."; }
+    }
+    public override IEnumerable<string> Structure {
+      get { return new string[] { "&File", "&Export" }; }
+    }
+    public override int Position {
+      get { return 1601; }
+    }
+
+    protected override void OnToolStripItemSet(EventArgs e) {
+      ToolStripItem.Enabled = false;
+    }
+    protected override void OnActiveViewChanged(object sender, EventArgs e) {
+      IContentView activeView = MainFormManager.MainForm.ActiveView as IContentView;
+      ToolStripItem.Enabled = (activeView != null) && (activeView.Content != null) &&
+                              (activeView.Content is IStorableContent) && !activeView.Locked && activeView.Enabled;
+    }
+
+    public override void Execute() {
+      FileManager.ExportJsonTemplate();
+    }
+  }
+}
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/MenuItems/ImportJsonTemplateMenuItem.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/MenuItems/ImportJsonTemplateMenuItem.cs	(revision 17331)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/MenuItems/ImportJsonTemplateMenuItem.cs	(revision 17331)
@@ -0,0 +1,27 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using HeuristicLab.Common;
+using HeuristicLab.MainForm;
+using HeuristicLab.Optimizer;
+
+namespace HeuristicLab.JsonInterface.OptimizerIntegration.MenuItems {
+  internal class ImportJsonTemplateMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItem, IOptimizerUserInterfaceItemProvider {
+    public override string Name {
+      get { return "Json-Template..."; }
+    }
+    public override IEnumerable<string> Structure {
+      get { return new string[] { "&File", "&Import" }; }
+    }
+    public override int Position {
+      get { return 1501; }
+    }
+
+
+    public override void Execute() {
+      FileManager.ImportJsonTemplate();
+    }
+  }
+}
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Plugin.cs.frame
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Plugin.cs.frame	(revision 17331)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Plugin.cs.frame	(revision 17331)
@@ -0,0 +1,38 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.JsonInterface.OptimizerIntegration
+{
+  [Plugin("HeuristicLab.JsonInterface.OptimizerIntegration", "3.3.16.0")]
+  [PluginFile("HeuristicLab.JsonInterface.OptimizerIntegration.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Attic", "1.0")]
+  [PluginDependency("HeuristicLab.JsonInterface", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.MainForm", "3.3")]
+  [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
+  [PluginDependency("HeuristicLab.Optimizer", "3.3")]
+  public class HeuristicLabJsonInterfaceAppPlugin : PluginBase {
+  }
+}
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Properties/AssemblyInfo.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Properties/AssemblyInfo.cs	(revision 17331)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Properties/AssemblyInfo.cs	(revision 17331)
@@ -0,0 +1,36 @@
+﻿using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.JsonInterface.OptimizerIntegration")]
+[assembly: AssemblyDescription("")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("HeuristicLab.JsonInterface.OptimizerIntegration")]
+[assembly: AssemblyCopyright("Copyright ©  2019")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible
+// to COM components.  If you need to access a type in this assembly from
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("5a3413f8-0928-4167-80e7-aad9d6e38a94")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("1.0.0.0")]
+[assembly: AssemblyFileVersion("1.0.0.0")]
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj	(revision 17330)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj	(revision 17331)
@@ -161,4 +161,6 @@
     </Compile>
     <Compile Include="MenuItems\ChangeNestingLevelMenuItem.cs" />
+    <Compile Include="MenuItems\ExportMenuItem.cs" />
+    <Compile Include="MenuItems\ImportMenuItem.cs" />
     <Compile Include="OptimizerSingleDocumentMainForm.cs">
       <SubType>Form</SubType>
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Optimizer/3.3/MenuItems/CloseAllMenuItem.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Optimizer/3.3/MenuItems/CloseAllMenuItem.cs	(revision 17330)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Optimizer/3.3/MenuItems/CloseAllMenuItem.cs	(revision 17331)
@@ -36,5 +36,5 @@
     }
     public override int Position {
-      get { return 1600; }
+      get { return 1800; }
     }
     public override Keys ShortCutKeys {
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Optimizer/3.3/MenuItems/CloseMenuItem.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Optimizer/3.3/MenuItems/CloseMenuItem.cs	(revision 17330)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Optimizer/3.3/MenuItems/CloseMenuItem.cs	(revision 17331)
@@ -35,5 +35,5 @@
     }
     public override int Position {
-      get { return 1500; }
+      get { return 1700; }
     }
     public override Keys ShortCutKeys {
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Optimizer/3.3/MenuItems/ExportMenuItem.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Optimizer/3.3/MenuItems/ExportMenuItem.cs	(revision 17331)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Optimizer/3.3/MenuItems/ExportMenuItem.cs	(revision 17331)
@@ -0,0 +1,41 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using System.Windows.Forms;
+using HeuristicLab.Common;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Optimizer.MenuItems {
+  class ExportMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItem, IOptimizerUserInterfaceItemProvider {
+    public override string Name {
+      get { return "&Export"; }
+    }
+    public override IEnumerable<string> Structure {
+      get { return new string[] { "&File" }; }
+    }
+    public override int Position {
+      get { return 1600; }
+    }
+    public override Keys ShortCutKeys {
+      get { return Keys.Control | Keys.Shift | Keys.S; }
+    }
+
+    protected override void OnToolStripItemSet(EventArgs e) {
+      ToolStripItem.Enabled = IsUseable();
+    }
+    protected override void OnActiveViewChanged(object sender, EventArgs e) {
+      ToolStripItem.Enabled = IsUseable();
+    }
+
+    private bool IsUseable() {
+      IContentView activeView = MainFormManager.MainForm.ActiveView as IContentView;
+      return (activeView != null) && (activeView.Content != null) &&
+             (activeView.Content is IStorableContent) && !activeView.Locked && activeView.Enabled &&
+             ToolStripItem.IsOnDropDown && ((ToolStripDropDownItem)ToolStripItem).DropDownItems.Count > 0;
+    }
+
+    public override void Execute() { }
+  }
+}
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Optimizer/3.3/MenuItems/ImportMenuItem.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Optimizer/3.3/MenuItems/ImportMenuItem.cs	(revision 17331)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Optimizer/3.3/MenuItems/ImportMenuItem.cs	(revision 17331)
@@ -0,0 +1,36 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using System.Windows.Forms;
+using HeuristicLab.Common;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Optimizer.MenuItems {
+  internal class ImportMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItem, IOptimizerUserInterfaceItemProvider {
+    public override string Name {
+      get { return "&Import"; }
+    }
+    public override IEnumerable<string> Structure {
+      get { return new string[] { "&File" }; }
+    }
+    public override int Position {
+      get { return 1500; }
+    }
+    public override Keys ShortCutKeys {
+      get { return Keys.Control | Keys.Shift | Keys.S; }
+    }
+
+    protected override void OnToolStripItemSet(EventArgs e) =>
+      ToolStripItem.Enabled = IsUseable();
+    
+    protected override void OnActiveViewChanged(object sender, EventArgs e) =>
+      ToolStripItem.Enabled = IsUseable();
+
+    private bool IsUseable() => ToolStripItem.IsOnDropDown && 
+      ((ToolStripDropDownItem)ToolStripItem).DropDownItems.Count > 0;
+
+    public override void Execute() {}
+  }
+}
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Optimizer/3.3/MenuItems/Separators.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Optimizer/3.3/MenuItems/Separators.cs	(revision 17330)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Optimizer/3.3/MenuItems/Separators.cs	(revision 17331)
@@ -24,5 +24,5 @@
 
 namespace HeuristicLab.Optimizer.MenuItems {
-  internal class SeparatorMenuItem : MenuSeparatorItem, IOptimizerUserInterfaceItemProvider {
+  internal class FileBeforeExitSeperator : MenuSeparatorItem, IOptimizerUserInterfaceItemProvider {
     public override IEnumerable<string> Structure {
       get { return new string[] { "&File" }; }
@@ -33,3 +33,26 @@
     }
   }
+
+  internal class FileAfterSaveAsSeperator : MenuSeparatorItem, IOptimizerUserInterfaceItemProvider {
+    public override IEnumerable<string> Structure {
+      get { return new string[] { "&File" }; }
+    }
+
+    public override int Position {
+      get { return 1499; }
+    }
+  }
+
+  internal class FileBeforeCloseSeperator : MenuSeparatorItem, IOptimizerUserInterfaceItemProvider
+  {
+    public override IEnumerable<string> Structure
+    {
+      get { return new string[] { "&File" }; }
+    }
+
+    public override int Position
+    {
+      get { return 1699; }
+    }
+  }
 }